Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class InstanceOfExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.InstanceOfExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class InstanceOfExpression

extends UnaryExpression

InstanceOf Expression: implements "Expr instance of data-type"

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`InstanceOfExpression(Expression source, SequenceType target)`

Method Summary
`int` | `computeCardinality()` Determine the cardinality
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`boolean` | `effectiveBooleanValue(XPathContext context)` Evaluate the expression as a boolean
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the result of the InstanceOf expression
`int` | `getRequiredCardinality()` Get the cardinality that we are testing for membership of
`ItemType` | `getRequiredItemType()` Get the item type that we are testing for membership of
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`computeSpecialProperties, getBaseExpression, hashCode, iterateSubExpressions, promote, replaceSubExpression, simplify`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InstanceOfExpression

    public InstanceOfExpression(Expression source,
                                SequenceType target)

Method Detail

### getRequiredItemType

    public ItemType getRequiredItemType()

  Get the item type that we are testing for membership of

  Returns:
    the item type

### getRequiredCardinality

    public int getRequiredCardinality()

  Get the cardinality that we are testing for membership of

  Returns:
    the required cardinality

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the checked expression
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `UnaryExpression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### computeCardinality

    public int computeCardinality()

  Determine the cardinality

  Overrides:
    `computeCardinality` in class `UnaryExpression`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the result of the InstanceOf expression

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` -
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Evaluate the expression as a boolean

  Overrides:
    `effectiveBooleanValue` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Overrides:
    `display` in class `UnaryExpression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.